<?php
	
	require 'functions.php';

	if(!logged_in())
	{
		redirect('login');
	}

	$page = $_GET['page'] ?? 1;
	$page = (int)$page;
	if($page < 1)
		$page = 1;

	$limit = 20;
	$offset = ($page - 1) * $limit;

	$query = "select * from employees order by id desc limit $limit offset $offset";
	$rows = query($query);


	if(empty($rows)){
		$rows = null;
	}else{
		foreach ($rows as $key => $row) {
			$rows[$key]['image'] = get_image($row['image']);
			$rows[$key]['date'] = date("jS F, Y H:i:s a",strtotime($row['date']));
		}
	}


?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Employee list</title>
	<link rel="stylesheet" type="text/css" href="assets_index/css/bootstrap-icons.css">
	<link rel="stylesheet" type="text/css" href="assets_index/css/styles.css?v1">
</head>
<body>

	<style type="text/css">
		
		.hide{
			display: none;
		}
	</style>
	<section class="class_1" >
		<h1 class="class_2" style="margin-bottom: 0px;"  >
			Employees
		</h1>
		<div style="background-color: white;text-align: center;">
			Hi, <?=$_SESSION['USER']['username']?> &nbsp
			<a href="logout.php">[Logout]</a>
		</div>
		<button onclick="show_add_new_record()" class="class_12"  >
			Add new
		</button>

		<div class="class_3" >
			<div class="class_4" >
				<table  class="item_class_0 class_5">
					
					<thead >
						
						<tr >
							
							<th scope="col" >
								#
							</th>
							
							<th scope="col" >
								First Name
								<br>
							</th>
							
							<th scope="col" >
								Last Name
								<br>
							</th>
							
							<th scope="col" >
								Phone
							</th>
							
							<th scope="col" >
								Email
							</th>
							
							<th >
								Action
							</th>
						</tr>
						
					</thead>
					
					<tbody class="js-rows" >
						
						<?php if(!empty($rows)):?>
							<?php foreach($rows as $row):?>
	 
								<tr id="row_<?=$row['id']?>" onclick="select_record(event)" class="item_class_1 class_10">
									
									<th >
										<?=$row['id']?>
									</th>
									
									<td >
										<?=htmlspecialchars($row['first_name'])?>
									</td>
									
									<td >
										<?=htmlspecialchars($row['last_name'])?>
									</td>
									
									<td >
										<?=htmlspecialchars($row['phone'])?>
									</td>
									
									<td >
										<?=htmlspecialchars($row['email'])?>
									</td>
									
									<td  class="class_7">
										<i onclick="show_add_new_record(<?=$row['id']?>)" class="bi bi-pencil-square class_8"></i>
										<i onclick="delete_record(<?=$row['id']?>)" class="bi bi-trash3-fill class_9"></i>
									</td>
								</tr>
							<?php endforeach;?>
						<?php endif;?>
					</tbody>
				</table>
				<div class="class_11" >
					<div class="class_11" >
						<a href="index.php">
							<button class="class_12"  >
								First page
							</button>
						</a>
						<a href="index.php?page=<?=$page-1?>">
							<button class="class_12"  >
								Prev page
							</button>
						</a>
					</div>
					<div class="class_13"  >
						Page <?=$page?>
					</div>
					<a href="index.php?page=<?=$page+1?>">
						<button class="class_12"  >
							Next page
						</button>
					</a>
				</div>
			</div>
			<div class="js-info-none class_14" >
				<div class="class_15" >
					<h1>No row selected</h1>
					<h4>Please click on a row to see details here</h4>
				</div>
			</div>
			<div class="js-info class_14 hide" >
				<div class="class_15" >
					
					<div class="class_16" >
						<img src="assets_index/images/product6.jpg" class="class_17" >
					</div>
					<img src="assets_index/images/no_image.jpg" class="js-info-image class_18" >
					<h1 class="js-info-name class_19"  >
						Jane Doe
					</h1>
					<div class="js-info-gender class_20"  >
						Female
					</div>
					<div class="class_3" >
						<div class="class_21" >
							<h1 class="class_22"  >
								Phone
							</h1>
							<div class="js-info-phone class_20"  >
								0000 000 0000
							</div>
						</div>
						<div class="class_21" >
							<h1 class="class_22"  >
								Email
							</h1>
							<div class="js-info-email class_20"  >
								example@email.com
							</div>
						</div>
					</div>
					<hr style="opacity: 0.2;">
					<h1 class="class_24"  >
						Address:
					</h1>
					<div class="js-info-address class_25"  >
						...
					</div>
					<hr style="opacity: 0.2;">
					<h1 class="class_24"  >
						Comment:
					</h1>
					<div class="js-info-comment class_25"  >
						...
					</div>
					<hr style="opacity: 0.2;">
					<h1 class="class_24"  >
						Date Created:
					</h1>
					<div class="js-info-date class_25"  >
						...
					</div>
					
				</div>
			</div>
		</div>

		<div class="js-add-new-popup class_26 hide"  >
			<div style="text-align:right">
				<button onclick="hide_add_new_record()" class="class_12" style="display:inline-block;background-color: red;"  >
					X
				</button>
			</div>
			<div class="errors" style="color:red"></div>
			<label>
				<img src="assets_index/images/no_image.jpg" class="class_27" style="cursor: pointer;" >
				<input onchange="display_image(this)" type="file" name="image"  class="class_28">
			</label>

			<div class="class_29" >
				<div class="class_30" >
					<label class="class_31"  >
						First Name:
					</label>
					<input placeholder="First name" type="text" name="first_name" class="class_32" >
				</div>
				<div class="class_30" >
					<label class="class_31"  >
						Last Name:
					</label>
					<input placeholder="Last name" type="text" name="last_name" class="class_32" >
				</div>
				<div class="class_30" >
					<label class="class_31"  >
						Email:
					</label>
					<input placeholder="Email" type="text" name="email" class="class_32" >
				</div>
				<div class="class_30" >
					<label class="class_31"  >
						Phone:
					</label>
					<input placeholder="Phone number" type="text" name="phone" class="class_32" >
				</div>
				
				<div class="class_33" >
					<select class="class_32"  name="gender">
						<option value="">
							--Select Gender--
						</option>
						<option >
							Male
						</option>
						<option >
							Female
						</option>
					</select>
				</div>
				<div class="class_30" >
					<label class="class_34"  >
						Address:
					</label>
					<textarea placeholder="Address" name="address" class="class_32" ></textarea>
				</div>
				<div class="class_30" >
					<label class="class_34"  >
						Comment:
					</label>
					<textarea placeholder="Comment" name="comment" class="class_32" ></textarea>
				</div>
				<div style="text-align:center">
					<button onclick="add_new_record()" class="class_12" style="display:inline-block;background-color: red;"  >
						Save
					</button>
				</div>

			</div>
		</div>
	</section>
	<div class="class_35" >
	</div>
	
</body>
</html>

<script>
	
	var image_added = false;
	var edit_mode = false;
	var ROW_ID = 0;
	var ROWS = JSON.parse('<?=json_encode($rows ?? [])?>');

	function show_add_new_record(id = null){
		
		let popup = document.querySelector(".js-add-new-popup");
		popup.classList.remove('hide');
		let inputs = popup.querySelectorAll("input,select,textarea");

		if(id){
			edit_mode = true;
			ROW_ID = id;

			let row = get_row(id);
			//display existing row values in inputs
			
			for (var i = inputs.length - 1; i >= 0; i--) {
				inputs[i].value = row[inputs[i].name];
			}

		}else{
			edit_mode = false;
			
			for (var i = inputs.length - 1; i >= 0; i--) {
				inputs[i].value = "";
			}

		}
	}
	
	function hide_add_new_record(){
		
		let popup = document.querySelector(".js-add-new-popup");
		popup.classList.add('hide');
	}

	function add_new_record(){
		
		let popup = document.querySelector(".js-add-new-popup");
		
		let optional = ['comment','address','image'];
		let inputs = popup.querySelectorAll("input,select,textarea");
		
		let obj = {};
		for (var i = inputs.length - 1; i >= 0; i--) {
			
			if(inputs[i].value == "" && !optional.includes(inputs[i].name)){
				alert(inputs[i].name.replaceAll("_"," ") + " can not be empty");
				return;
			}

			if(inputs[i].name == "image"){
				if(image_added)
					obj[inputs[i].name] = inputs[i].files[0];
			}else{
				obj[inputs[i].name] = inputs[i].value;
			}
		}

		//save
		obj.data_type = 'add_record';

		if(edit_mode){
			obj.id = ROW_ID;
		}
 
 		send_data(obj);
 		edit_mode = false;

	}

	function send_data(obj)
	{
		let myform = new FormData();
		for (key in obj) {
			myform.append(key, obj[key]);
		}

		var ajax = new XMLHttpRequest();

		ajax.addEventListener('readystatechange',function(){

			if(ajax.readyState == 4)
			{
				if(ajax.status == 200)
				{
					//result
					handle_result(ajax.responseText);
				}else{
					alert("Could not connect!");
				}
			}
		});

		ajax.open('post','ajax.php', true);
		ajax.send(myform);
	}

	function handle_result(result)
	{
		console.log(result);

		let obj = JSON.parse(result);
		if(obj.data_type == 'add_record')
		{
			if(obj.success){
				alert(obj.message);
				window.location.reload();
			}else{
				alert(obj.message);
				let popup = document.querySelector(".js-add-new-popup");
				let str = "";
				for(key in obj.errors)
				{
					str += `${obj.errors[key]}<br>`;
				}
				popup.querySelector(".errors").innerHTML = str;
			}
		}else 
		if(obj.data_type == 'delete_record')
		{
			if(obj.success){
				alert(obj.message);
				window.location.reload();
			}else{
				alert(obj.message);
			}
		}
		
	}

	function display_image(ele)
	{
		let file = ele.files[0];
		let allowed = ['image/jpeg','image/png','image/gif','image/webp'];

		if(!allowed.includes(file.type)){

			alert("Only files of this type accepted: " + allowed.toString().replaceAll("image/",""));
			image_added = false;
			return;
		}

		image_added = true;
		ele.parentNode.querySelector("img").src = URL.createObjectURL(file);
	}

	function select_record(e)
	{
		let tr = e.currentTarget;
		ROW_ID = parseInt(tr.id.replace("row_",""));

		//remove other selected rows
		let tbody = document.querySelector(".js-rows");
		for (var i = tbody.children.length - 1; i >= 0; i--) {
			tbody.children[i].classList.remove("class_6");
		}

		tr.classList.add("class_6");
		display_info(get_row(ROW_ID));
	}

	function get_row(id)
	{
		for (var i = ROWS.length - 1; i >= 0; i--) {
			
			if(ROWS[i].id == id){
				return ROWS[i];
			}
		}

		return {};
	}

	function display_info(obj)
	{
		let info_div = document.querySelector(".js-info");
		let info_div_none = document.querySelector(".js-info-none");
		info_div_none.classList.add("hide");
		info_div.classList.remove("hide");

		info_div.querySelector(".js-info-name").innerHTML = obj.first_name +" "+ obj.last_name;
		info_div.querySelector(".js-info-gender").innerHTML = obj.gender;
		info_div.querySelector(".js-info-email").innerHTML = obj.email;
		info_div.querySelector(".js-info-phone").innerHTML = obj.phone;
		info_div.querySelector(".js-info-address").innerHTML = obj.address;
		info_div.querySelector(".js-info-comment").innerHTML = obj.comment;
		info_div.querySelector(".js-info-date").innerHTML = obj.date;
		info_div.querySelector(".js-info-image").src = obj.image;
	}

	function delete_record(id)
	{
		if(!confirm("Are you sure you want to delete record number "+ id)){
			return;
		}

		//delete
		let obj = {};
		obj.data_type = "delete_record";
		obj.id = id;

		send_data(obj);
	}

</script>